<template>
    <div class="list-view">
        <page-title>
            <el-button
                @click="addRow"
                type="primary"
                icon="el-icon-plus"
                :disabled="fetchingData || downloading"
                class="filter-item"
            >
                新增
            </el-button>
            <!-- <el-button
                @click="download"
                icon="el-icon-upload2"
                :loading="downloading"
                :disabled="fetchingData || totalElements < 1"
                class="filter-item"
            >
                导出
            </el-button> -->
        </page-title>
        <div class="filters-container">
            <el-input
                placeholder="搜索..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="getData"
            >
                <el-button @click="getData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
            <setting-select name="所属领域" :flag="1" v-model="settingId" @input="getData"></setting-select>
            <mode-select v-model="mode"></mode-select>
            <el-select
                v-model="patentType"
                placeholder="请选择专利分类"
                clearable
                class="filter-item"
                @change="getData"
            >
                <el-option
                    v-for="item in patentTypeOptions"
                    :key="item.value"
                    :value="item.value"
                    :label="item.label"
                ></el-option>
            </el-select>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
            v-loading="fetchingData"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="60"> </el-table-column>
            <el-table-column prop="name" label="名称"> </el-table-column>
            <el-table-column prop="patentType" label="专利类型" :formatter="patentTypeFormatter"> </el-table-column>
            <el-table-column prop="img" label="封面">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px"
                        :src="row.img"
                        fit="cover"
                        :preview-src-list="[row.img]"
                    ></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="setting.name" label="所属领域"> </el-table-column>
            <el-table-column prop="soldAt" label="成交时间"> </el-table-column>
            <el-table-column prop="soldPrice" label="成交价格"> </el-table-column>
            <el-table-column prop="mode" label="交易方式" :formatter="modeFormatter"> </el-table-column>
            <el-table-column prop="soldAddress" label="成交地点"> </el-table-column>
            <!-- <el-table-column prop="manual" label="描述"> </el-table-column> -->
            <el-table-column prop="view" label="浏览量"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" width="150">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import ModeSelect from '../../components/select/ModeSelect2.vue';
import SettingSelect from '../../components/select/SettingSelect.vue';

export default {
    name: 'GeneralPatentCaseList',
    mixins: [pageableTable],
    components: { ModeSelect, SettingSelect },
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/successCase/all',
            downloading: false,
            patentTypeOptions: [
                { label: '发明', value: 'INVENTION' },
                { label: '实用新型', value: 'UTILITY_MODEL' },
                { label: '外观设计', value: 'APPEARANCE_DESIGN' }
            ],
            modeOptions: [
                { label: '转让', value: 'TRANSFER' },
                { label: '许可', value: 'PERMIT' },
                { label: '入股', value: 'INVEST' }
            ],
            mode: '',
            settingId: '',
            patentType: ''
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        patentTypeFormatter(row, column, cellValue, index) {
            let selectedOption = this.patentTypeOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        modeFormatter(row, column, cellValue, index) {
            let selectedOption = this.modeOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return {
                sort: 'soldPrice,desc',
                search: this.search,
                query: {
                    category: 'GENERAL',
                    mode: this.mode,
                    settingId: this.settingId,
                    patentType: this.patentType
                }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/successCaseEdit',
                query: {
                    ...this.$route.query,
                    category: 'GENERAL'
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/successCaseEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/successCase/excel', {
                    responseType: 'blob',
                    params: {
                        size: 10000,
                        query: {
                            category: 'GENERAL',
                            mode: this.mode,
                            settingId: this.settingId,
                            patentType: this.patentType
                        }
                    }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/successCase/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
